/* ***********************************************************
 * This file was automatically generated on 2012-10-07.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device for receiving GPS position
	/// </summary>
	public class BrickletGPS : Device 
	{
		private static byte FUNCTION_GET_COORDINATES = 1;
		private static byte FUNCTION_GET_STATUS = 2;
		private static byte FUNCTION_RESTART = 3;
		private static byte FUNCTION_SET_COORDINATES_CALLBACK_PERIOD = 4;
		private static byte FUNCTION_GET_COORDINATES_CALLBACK_PERIOD = 5;
		private static byte FUNCTION_SET_STATUS_CALLBACK_PERIOD = 6;
		private static byte FUNCTION_GET_STATUS_CALLBACK_PERIOD = 7;
		private static byte CALLBACK_COORDINATES = 8;
		private static byte CALLBACK_STATUS = 9;


		/// <summary>
		///  
		/// </summary>
		public delegate void Coordinates(char ns, ushort[] latitude, char ew, ushort[] longitude, ushort pdop, ushort hdop, ushort vdop);

		/// <summary>
		///  
		/// </summary>
		public delegate void Status(byte fix, byte satellitesView, byte satellitesUsed, ushort speed, ushort course, uint date, uint time, short altitude, short altitudeAccuracy);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c>. This object can
		///  then be added to the IP connection.
		/// </summary>
		public BrickletGPS(string uid) : base(uid) 
		{
			this.expectedName = "GPS Bricklet";
			this.bindingVersion[0] = 1;
			this.bindingVersion[1] = 0;
			this.bindingVersion[2] = 0;
			messageCallbacks[CALLBACK_COORDINATES] = new MessageCallback(CallbackCoordinates);
			messageCallbacks[CALLBACK_STATUS] = new MessageCallback(CallbackStatus);
		}

		/// <summary>
		///  
		/// </summary>
		public void GetCoordinates(out char ns, out ushort[] latitude, out char ew, out ushort[] longitude, out ushort pdop, out ushort hdop, out ushort vdop)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_COORDINATES, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_COORDINATES, out response);

			ns = LEConverter.CharFrom(4, response);
			latitude = LEConverter.UShortArrayFrom(5, response, 2);
			ew = LEConverter.CharFrom(9, response);
			longitude = LEConverter.UShortArrayFrom(10, response, 2);
			pdop = LEConverter.UShortFrom(14, response);
			hdop = LEConverter.UShortFrom(16, response);
			vdop = LEConverter.UShortFrom(18, response);
		}

		/// <summary>
		///  
		/// </summary>
		public void GetStatus(out byte fix, out byte satellitesView, out byte satellitesUsed, out ushort speed, out ushort course, out uint date, out uint time, out short altitude, out short altitudeAccuracy)
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_STATUS, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_STATUS, out response);

			fix = LEConverter.ByteFrom(4, response);
			satellitesView = LEConverter.ByteFrom(5, response);
			satellitesUsed = LEConverter.ByteFrom(6, response);
			speed = LEConverter.UShortFrom(7, response);
			course = LEConverter.UShortFrom(9, response);
			date = LEConverter.UIntFrom(11, response);
			time = LEConverter.UIntFrom(15, response);
			altitude = LEConverter.ShortFrom(19, response);
			altitudeAccuracy = LEConverter.ShortFrom(21, response);
		}

		/// <summary>
		///  
		/// </summary>
		public void Restart(byte restartType)
		{
			byte[] data_ = new byte[5];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_RESTART, 1, data_);
			LEConverter.To((ushort)5, 2, data_);
			LEConverter.To(restartType, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  
		/// </summary>
		public void SetCoordinatesCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_COORDINATES_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletGPS.SetCoordinatesCallbackPeriod"/>.
		/// </summary>
		public uint GetCoordinatesCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_COORDINATES_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_COORDINATES_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  
		/// </summary>
		public void SetStatusCallbackPeriod(uint period)
		{
			byte[] data_ = new byte[8];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_SET_STATUS_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)8, 2, data_);
			LEConverter.To(period, 4, data_);

			SendRequestNoResponse(data_);
		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletGPS.GetStatusCallbackPeriod"/>.
		/// </summary>
		public uint GetStatusCallbackPeriod()
		{
			byte[] data_ = new byte[4];
			LEConverter.To(stackID, 0, data_);
			LEConverter.To(FUNCTION_GET_STATUS_CALLBACK_PERIOD, 1, data_);
			LEConverter.To((ushort)4, 2, data_);

			byte[] response;
			SendRequestExpectResponse(data_, FUNCTION_GET_STATUS_CALLBACK_PERIOD, out response);

			return LEConverter.UIntFrom(4, response);
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetCoordinatesCallbackPeriod(out uint period)
		{
			period = GetCoordinatesCallbackPeriod();
		}

		/// <summary>
		///  Obsolete. Use overloaded version instead that returns the result.
		/// </summary>
		[Obsolete()]
		public void GetStatusCallbackPeriod(out uint period)
		{
			period = GetStatusCallbackPeriod();
		}

		internal int CallbackCoordinates(byte[] data_)
		{
			char ns = LEConverter.CharFrom(4, data_);
			ushort[] latitude = LEConverter.UShortArrayFrom(5, data_, 2);
			char ew = LEConverter.CharFrom(9, data_);
			ushort[] longitude = LEConverter.UShortArrayFrom(10, data_, 2);
			ushort pdop = LEConverter.UShortFrom(14, data_);
			ushort hdop = LEConverter.UShortFrom(16, data_);
			ushort vdop = LEConverter.UShortFrom(18, data_);

			((Coordinates)callbacks[CALLBACK_COORDINATES])(ns, latitude, ew, longitude, pdop, hdop, vdop);
			return 20;
		}

		internal int CallbackStatus(byte[] data_)
		{
			byte fix = LEConverter.ByteFrom(4, data_);
			byte satellitesView = LEConverter.ByteFrom(5, data_);
			byte satellitesUsed = LEConverter.ByteFrom(6, data_);
			ushort speed = LEConverter.UShortFrom(7, data_);
			ushort course = LEConverter.UShortFrom(9, data_);
			uint date = LEConverter.UIntFrom(11, data_);
			uint time = LEConverter.UIntFrom(15, data_);
			short altitude = LEConverter.ShortFrom(19, data_);
			short altitudeAccuracy = LEConverter.ShortFrom(21, data_);

			((Status)callbacks[CALLBACK_STATUS])(fix, satellitesView, satellitesUsed, speed, course, date, time, altitude, altitudeAccuracy);
			return 23;
		}

		/// <summary>
		///  Registers a callback function.
		/// </summary>
		public void RegisterCallback(System.Delegate d)
		{
			if(d.GetType() == typeof(Coordinates))
			{
				callbacks[CALLBACK_COORDINATES] = d;
			}
			else if(d.GetType() == typeof(Status))
			{
				callbacks[CALLBACK_STATUS] = d;
			}
		}
	}
}
